---
# Cop supports --autocorrect.
Style/RedundantSelf:
  Exclude:
    - 'app/models/application_setting.rb'
    - 'app/models/ci/group.rb'
    - 'app/models/ci/job_artifact.rb'
    - 'app/models/ci/job_token/project_scope_link.rb'
    - 'app/models/ci/namespace_mirror.rb'
    - 'app/models/ci/pending_build.rb'
    - 'app/models/ci/pipeline.rb'
    - 'app/models/ci/pipeline_artifact.rb'
    - 'app/models/ci/processable.rb'
    - 'app/models/ci/ref.rb'
    - 'app/models/ci/resource_group.rb'
    - 'app/models/ci/runner.rb'
    - 'app/models/ci/running_build.rb'
    - 'app/models/ci/stage.rb'
    - 'app/models/ci/trigger.rb'
    - 'app/models/ci_platform_metric.rb'
    - 'app/models/clusters/applications/cert_manager.rb'
    - 'app/models/clusters/applications/crossplane.rb'
    - 'app/models/clusters/cluster.rb'
    - 'app/models/clusters/concerns/application_core.rb'
    - 'app/models/clusters/concerns/application_status.rb'
    - 'app/models/clusters/platforms/kubernetes.rb'
    - 'app/models/commit.rb'
    - 'app/models/commit_range.rb'
    - 'app/models/commit_status.rb'
    - 'app/models/compare.rb'
    - 'app/models/concerns/after_commit_queue.rb'
    - 'app/models/concerns/atomic_internal_id.rb'
    - 'app/models/concerns/avatarable.rb'
    - 'app/models/concerns/awardable.rb'
    - 'app/models/concerns/bulk_member_access_load.rb'
    - 'app/models/concerns/bulk_users_by_email_load.rb'
    - 'app/models/concerns/cache_markdown_field.rb'
    - 'app/models/concerns/ci/metadatable.rb'
    - 'app/models/concerns/counter_attribute.rb'
    - 'app/models/concerns/cross_database_modification.rb'
    - 'app/models/concerns/deployment_platform.rb'
    - 'app/models/concerns/diff_positionable_note.rb'
    - 'app/models/concerns/featurable.rb'
    - 'app/models/concerns/has_user_type.rb'
    - 'app/models/concerns/has_wiki.rb'
    - 'app/models/concerns/has_wiki_page_meta_attributes.rb'
    - 'app/models/concerns/ignorable_columns.rb'
    - 'app/models/concerns/integrations/base_data_fields.rb'
    - 'app/models/concerns/integrations/has_data_fields.rb'
    - 'app/models/concerns/issuable.rb'
    - 'app/models/concerns/issue_resource_event.rb'
    - 'app/models/concerns/limitable.rb'
    - 'app/models/concerns/mentionable.rb'
    - 'app/models/concerns/merge_request_reviewer_state.rb'
    - 'app/models/concerns/noteable.rb'
    - 'app/models/concerns/participable.rb'
    - 'app/models/concerns/pg_full_text_searchable.rb'
    - 'app/models/concerns/protected_ref.rb'
    - 'app/models/concerns/protected_ref_access.rb'
    - 'app/models/concerns/reactive_caching.rb'
    - 'app/models/concerns/redis_cacheable.rb'
    - 'app/models/concerns/resolvable_discussion.rb'
    - 'app/models/concerns/resolvable_note.rb'
    - 'app/models/concerns/routable.rb'
    - 'app/models/concerns/sortable.rb'
    - 'app/models/concerns/spammable.rb'
    - 'app/models/concerns/timebox.rb'
    - 'app/models/concerns/ttl_expirable.rb'
    - 'app/models/concerns/valid_attribute.rb'
    - 'app/models/container_expiration_policy.rb'
    - 'app/models/container_repository.rb'
    - 'app/models/custom_emoji.rb'
    - 'app/models/customer_relations/contact.rb'
    - 'app/models/customer_relations/organization.rb'
    - 'app/models/deploy_key.rb'
    - 'app/models/deploy_keys_project.rb'
    - 'app/models/deployment.rb'
    - 'app/models/diff_note.rb'
    - 'app/models/discussion.rb'
    - 'app/models/email.rb'
    - 'app/models/environment.rb'
    - 'app/models/gpg_key.rb'
    - 'app/models/group.rb'
    - 'app/models/group_group_link.rb'
    - 'app/models/hooks/web_hook_log.rb'
    - 'app/models/identity.rb'
    - 'app/models/integration.rb'
    - 'app/models/integrations/base_chat_notification.rb'
    - 'app/models/integrations/base_ci.rb'
    - 'app/models/integrations/base_issue_tracker.rb'
    - 'app/models/integrations/base_slash_commands.rb'
    - 'app/models/integrations/campfire.rb'
    - 'app/models/integrations/emails_on_push.rb'
    - 'app/models/integrations/jira.rb'
    - 'app/models/integrations/pipelines_email.rb'
    - 'app/models/integrations/zentao.rb'
    - 'app/models/internal_id.rb'
    - 'app/models/issue.rb'
    - 'app/models/issue/metrics.rb'
    - 'app/models/issue_email_participant.rb'
    - 'app/models/key.rb'
    - 'app/models/label.rb'
    - 'app/models/legacy_diff_note.rb'
    - 'app/models/lfs_object.rb'
    - 'app/models/lfs_objects_project.rb'
    - 'app/models/member.rb'
    - 'app/models/members/project_member.rb'
    - 'app/models/merge_request.rb'
    - 'app/models/merge_request/cleanup_schedule.rb'
    - 'app/models/merge_request/metrics.rb'
    - 'app/models/merge_request_diff.rb'
    - 'app/models/merge_request_diff_commit.rb'
    - 'app/models/namespaces/traversal/linear.rb'
    - 'app/models/note.rb'
    - 'app/models/packages/dependency.rb'
    - 'app/models/packages/sem_ver.rb'
    - 'app/models/pages_domain.rb'
    - 'app/models/performance_monitoring/prometheus_dashboard.rb'
    - 'app/models/personal_access_token.rb'
    - 'app/models/plan.rb'
    - 'app/models/project.rb'
    - 'app/models/project_feature.rb'
    - 'app/models/project_group_link.rb'
    - 'app/models/project_import_data.rb'
    - 'app/models/project_label.rb'
    - 'app/models/prometheus_alert.rb'
    - 'app/models/protected_branch.rb'
    - 'app/models/protected_branch/push_access_level.rb'
    - 'app/models/protected_tag.rb'
    - 'app/models/raw_usage_data.rb'
    - 'app/models/release.rb'
    - 'app/models/release_highlight.rb'
    - 'app/models/remote_mirror.rb'
    - 'app/models/repository.rb'
    - 'app/models/sent_notification.rb'
    - 'app/models/serverless/function.rb'
    - 'app/models/service_desk_setting.rb'
    - 'app/models/snippet.rb'
    - 'app/models/terraform/state.rb'
    - 'app/models/todo.rb'
    - 'app/models/u2f_registration.rb'
    - 'app/models/upload.rb'
    - 'app/models/user.rb'
    - 'app/models/user_highest_role.rb'
    - 'app/models/x509_certificate.rb'
    - 'app/presenters/ci/build_runner_presenter.rb'
    - 'app/presenters/ci/pipeline_artifacts/code_coverage_presenter.rb'
    - 'app/presenters/ci/pipeline_artifacts/code_quality_mr_diff_presenter.rb'
    - 'app/presenters/projects/import_export/project_export_presenter.rb'
    - 'app/services/access_token_validation_service.rb'
    - 'app/services/clusters/kubernetes/create_or_update_service_account_service.rb'
    - 'app/services/dependency_proxy/auth_token_service.rb'
    - 'app/services/merge_requests/merge_service.rb'
    - 'app/services/projects/container_repository/delete_tags_service.rb'
    - 'app/services/projects/move_access_service.rb'
    - 'app/services/snippets/base_service.rb'
    - 'app/services/spam/spam_params.rb'
    - 'app/uploaders/file_uploader.rb'
    - 'app/uploaders/gitlab_uploader.rb'
    - 'app/uploaders/object_storage.rb'
    - 'app/workers/background_migration/single_database_worker.rb'
    - 'app/workers/build_hooks_worker.rb'
    - 'app/workers/concerns/application_worker.rb'
    - 'app/workers/concerns/limited_capacity/worker.rb'
    - 'app/workers/concerns/project_start_import.rb'
    - 'app/workers/concerns/reenqueuer.rb'
    - 'app/workers/database/batched_background_migration/single_database_worker.rb'
    - 'app/workers/group_import_worker.rb'
    - 'app/workers/project_export_worker.rb'
    - 'config/initializers/active_record_keyset_pagination.rb'
    - 'config/initializers/forbid_sidekiq_in_transactions.rb'
    - 'config/initializers/mail_encoding_patch.rb'
    - 'db/post_migrate/20211029102822_add_open_source_plan.rb'
    - 'ee/app/graphql/resolvers/geo/registries_resolver.rb'
    - 'ee/app/models/approval_merge_request_rule.rb'
    - 'ee/app/models/approval_project_rule.rb'
    - 'ee/app/models/concerns/approval_rule_like.rb'
    - 'ee/app/models/concerns/custom_model_naming.rb'
    - 'ee/app/models/concerns/ee/issuable_link.rb'
    - 'ee/app/models/concerns/ee/participable.rb'
    - 'ee/app/models/concerns/ee/protected_ref.rb'
    - 'ee/app/models/concerns/ee/protected_ref_access.rb'
    - 'ee/app/models/concerns/elastic/application_versioned_search.rb'
    - 'ee/app/models/concerns/elastic/projects_search.rb'
    - 'ee/app/models/concerns/elasticsearch_indexed_container.rb'
    - 'ee/app/models/concerns/geo/replicable_model.rb'
    - 'ee/app/models/concerns/geo/repository_replicator_strategy.rb'
    - 'ee/app/models/concerns/geo/verifiable_model.rb'
    - 'ee/app/models/concerns/geo/verifiable_registry.rb'
    - 'ee/app/models/concerns/geo/verifiable_replicator.rb'
    - 'ee/app/models/concerns/geo/verification_state.rb'
    - 'ee/app/models/concerns/geo/verification_state_definition.rb'
    - 'ee/app/models/ee/application_setting.rb'
    - 'ee/app/models/ee/audit_event.rb'
    - 'ee/app/models/ee/ci/bridge.rb'
    - 'ee/app/models/ee/description_version.rb'
    - 'ee/app/models/ee/environment.rb'
    - 'ee/app/models/ee/epic.rb'
    - 'ee/app/models/ee/group.rb'
    - 'ee/app/models/ee/group_member.rb'
    - 'ee/app/models/ee/issue.rb'
    - 'ee/app/models/ee/iteration.rb'
    - 'ee/app/models/ee/member.rb'
    - 'ee/app/models/ee/namespace.rb'
    - 'ee/app/models/ee/packages/package_file.rb'
    - 'ee/app/models/ee/project.rb'
    - 'ee/app/models/ee/project_feature.rb'
    - 'ee/app/models/ee/project_import_state.rb'
    - 'ee/app/models/ee/snippet_repository.rb'
    - 'ee/app/models/ee/user.rb'
    - 'ee/app/models/epic/metrics.rb'
    - 'ee/app/models/geo/base_registry.rb'
    - 'ee/app/models/geo/design_registry.rb'
    - 'ee/app/models/geo/project_registry.rb'
    - 'ee/app/models/geo/upload_registry.rb'
    - 'ee/app/models/geo_node.rb'
    - 'ee/app/models/geo_node_status.rb'
    - 'ee/app/models/gitlab_subscription.rb'
    - 'ee/app/models/gitlab_subscriptions/upcoming_reconciliation.rb'
    - 'ee/app/models/group_wiki_repository.rb'
    - 'ee/app/models/iterations/cadence.rb'
    - 'ee/app/models/license.rb'
    - 'ee/app/models/merge_requests/external_status_check.rb'
    - 'ee/app/models/push_rule.rb'
    - 'ee/app/models/security/orchestration_policy_configuration.rb'
    - 'ee/app/models/vulnerabilities/finding.rb'
    - 'ee/app/services/elastic/process_bookkeeping_service.rb'
    - 'ee/lib/api/dependencies.rb'
    - 'ee/lib/ee/gitlab/auth/ldap/sync/groups.rb'
    - 'ee/lib/ee/gitlab/auth/ldap/sync/proxy.rb'
    - 'ee/lib/ee/gitlab/auth/ldap/sync/users.rb'
    - 'ee/lib/ee/gitlab/background_migration/backfill_project_statistics_container_repository_size.rb'
    - 'ee/lib/ee/gitlab/background_migration/delete_invalid_epic_issues.rb'
    - 'ee/lib/ee/gitlab/background_migration/fix_incorrect_max_seats_used.rb'
    - 'ee/lib/ee/gitlab/background_migration/populate_uuids_for_security_findings.rb'
    - 'ee/lib/ee/gitlab/database.rb'
    - 'ee/lib/ee/gitlab/tracking.rb'
    - 'ee/lib/ee/legacy_model.rb'
    - 'ee/lib/ee/model.rb'
    - 'ee/lib/elastic/instance_proxy_util.rb'
    - 'ee/lib/elastic/latest/application_class_proxy.rb'
    - 'ee/lib/elastic/latest/commit_config.rb'
    - 'ee/lib/elastic/latest/issue_config.rb'
    - 'ee/lib/elastic/latest/merge_request_config.rb'
    - 'ee/lib/elastic/latest/note_config.rb'
    - 'ee/lib/elastic/migration.rb'
    - 'ee/lib/gem_extensions/elasticsearch/model/indexing/instance_methods.rb'
    - 'ee/lib/gitlab/analytics/cycle_analytics/summary/base_time.rb'
    - 'ee/lib/gitlab/auth/group_saml/response_check.rb'
    - 'ee/lib/gitlab/auth/group_saml/user.rb'
    - 'ee/lib/gitlab/auth/smartcard.rb'
    - 'ee/lib/gitlab/ci/reports/dependency_list/dependency.rb'
    - 'ee/lib/gitlab/ci/reports/dependency_list/vulnerability.rb'
    - 'ee/lib/gitlab/ci/reports/license_scanning/dependency.rb'
    - 'ee/lib/gitlab/ci/reports/license_scanning/report.rb'
    - 'ee/lib/gitlab/elastic/client.rb'
    - 'ee/lib/gitlab/elastic/document_reference.rb'
    - 'ee/lib/gitlab/elastic/helper.rb'
    - 'ee/lib/gitlab/geo.rb'
    - 'ee/lib/gitlab/geo/oauth/login_state.rb'
    - 'ee/lib/gitlab/geo/oauth/logout_state.rb'
    - 'ee/lib/gitlab/geo/replicator.rb'
    - 'ee/lib/gitlab/template/custom_template.rb'
    - 'ee/lib/system_check/app/search_check.rb'
    - 'ee/spec/helpers/ee/feature_flags_helper_spec.rb'
    - 'ee/spec/helpers/ee/graph_helper_spec.rb'
    - 'lib/api/entities/wiki_attachment.rb'
    - 'lib/api/helpers.rb'
    - 'lib/api/helpers/packages_helpers.rb'
    - 'lib/api/scope.rb'
    - 'lib/bulk_imports/clients/http.rb'
    - 'lib/bulk_imports/error.rb'
    - 'lib/bulk_imports/pipeline.rb'
    - 'lib/feature/definition.rb'
    - 'lib/gitlab.rb'
    - 'lib/gitlab/analytics/cycle_analytics/request_params.rb'
    - 'lib/gitlab/auth/ldap/access.rb'
    - 'lib/gitlab/auth/ldap/adapter.rb'
    - 'lib/gitlab/auth/ldap/auth_hash.rb'
    - 'lib/gitlab/auth/ldap/dn.rb'
    - 'lib/gitlab/auth/o_auth/provider.rb'
    - 'lib/gitlab/auth/result.rb'
    - 'lib/gitlab/background_migration/backfill_ci_queuing_tables.rb'
    - 'lib/gitlab/background_migration/backfill_project_repositories.rb'
    - 'lib/gitlab/background_migration/job_coordinator.rb'
    - 'lib/gitlab/background_migration/migrate_merge_request_diff_commit_users.rb'
    - 'lib/gitlab/cache/ci/project_pipeline_status.rb'
    - 'lib/gitlab/ci/ansi2html.rb'
    - 'lib/gitlab/ci/ansi2json/parser.rb'
    - 'lib/gitlab/ci/ansi2json/style.rb'
    - 'lib/gitlab/ci/build/policy.rb'
    - 'lib/gitlab/ci/build/step.rb'
    - 'lib/gitlab/ci/config/entry/job.rb'
    - 'lib/gitlab/ci/config/entry/jobs.rb'
    - 'lib/gitlab/ci/config/entry/root.rb'
    - 'lib/gitlab/ci/jwt.rb'
    - 'lib/gitlab/ci/parsers/coverage/sax_document.rb'
    - 'lib/gitlab/ci/pipeline/expression/lexeme/null.rb'
    - 'lib/gitlab/ci/pipeline/preloader.rb'
    - 'lib/gitlab/ci/queue/metrics.rb'
    - 'lib/gitlab/ci/reports/test_suite.rb'
    - 'lib/gitlab/ci/trace/stream.rb'
    - 'lib/gitlab/ci/variables/collection.rb'
    - 'lib/gitlab/ci/variables/collection/item.rb'
    - 'lib/gitlab/config/entry/configurable.rb'
    - 'lib/gitlab/config/entry/node.rb'
    - 'lib/gitlab/config/entry/simplifiable.rb'
    - 'lib/gitlab/cycle_analytics/summary/defaults.rb'
    - 'lib/gitlab/database.rb'
    - 'lib/gitlab/database/background_migration/batched_job.rb'
    - 'lib/gitlab/database/background_migration/batched_migration.rb'
    - 'lib/gitlab/database/background_migration_job.rb'
    - 'lib/gitlab/database/gitlab_schema.rb'
    - 'lib/gitlab/database/load_balancing/service_discovery.rb'
    - 'lib/gitlab/database/loose_foreign_keys.rb'
    - 'lib/gitlab/database/migration_helpers/restrict_gitlab_schema.rb'
    - 'lib/gitlab/database/migrations/background_migration_helpers.rb'
    - 'lib/gitlab/database/partitioning_migration_helpers/table_management_helpers.rb'
    - 'lib/gitlab/database/query_analyzers/base.rb'
    - 'lib/gitlab/database/query_analyzers/prevent_cross_database_modification.rb'
    - 'lib/gitlab/database/query_analyzers/restrict_allowed_schemas.rb'
    - 'lib/gitlab/database/rename_reserved_paths_migration/v1/migration_classes.rb'
    - 'lib/gitlab/database/shared_model.rb'
    - 'lib/gitlab/database/similarity_score.rb'
    - 'lib/gitlab/database/transaction/observer.rb'
    - 'lib/gitlab/diff/file.rb'
    - 'lib/gitlab/diff/rendered/notebook/diff_file.rb'
    - 'lib/gitlab/email/smtp_config.rb'
    - 'lib/gitlab/error_tracking/logger.rb'
    - 'lib/gitlab/feature_categories.rb'
    - 'lib/gitlab/git.rb'
    - 'lib/gitlab/git/blob.rb'
    - 'lib/gitlab/git/branch.rb'
    - 'lib/gitlab/git/repository.rb'
    - 'lib/gitlab/git/tree.rb'
    - 'lib/gitlab/git_access.rb'
    - 'lib/gitlab/github_import.rb'
    - 'lib/gitlab/graphql/deprecations_base.rb'
    - 'lib/gitlab/graphql/known_operations.rb'
    - 'lib/gitlab/graphql/lazy.rb'
    - 'lib/gitlab/graphql/representation/submodule_tree_entry.rb'
    - 'lib/gitlab/graphql/representation/tree_entry.rb'
    - 'lib/gitlab/graphql/tracers/application_context_tracer.rb'
    - 'lib/gitlab/graphql/tracers/logger_tracer.rb'
    - 'lib/gitlab/graphql/tracers/metrics_tracer.rb'
    - 'lib/gitlab/graphql/tracers/timer_tracer.rb'
    - 'lib/gitlab/highlight.rb'
    - 'lib/gitlab/http.rb'
    - 'lib/gitlab/import_export/error.rb'
    - 'lib/gitlab/import_export/hash_util.rb'
    - 'lib/gitlab/instrumentation/redis_base.rb'
    - 'lib/gitlab/jira_import.rb'
    - 'lib/gitlab/jwt_token.rb'
    - 'lib/gitlab/logger.rb'
    - 'lib/gitlab/marker_range.rb'
    - 'lib/gitlab/memory/instrumentation.rb'
    - 'lib/gitlab/patch/sprockets_base_file_digest_key.rb'
    - 'lib/gitlab/quick_actions/dsl.rb'
    - 'lib/gitlab/redis/hll.rb'
    - 'lib/gitlab/routing.rb'
    - 'lib/gitlab/rugged_instrumentation.rb'
    - 'lib/gitlab/search/query.rb'
    - 'lib/gitlab/session.rb'
    - 'lib/gitlab/sidekiq_config/cli_methods.rb'
    - 'lib/gitlab/sidekiq_status.rb'
    - 'lib/gitlab/sourcegraph.rb'
    - 'lib/gitlab/ssh_public_key.rb'
    - 'lib/gitlab/subscription_portal.rb'
    - 'lib/gitlab/template/base_template.rb'
    - 'lib/gitlab/template/dockerfile_template.rb'
    - 'lib/gitlab/template/gitignore_template.rb'
    - 'lib/gitlab/template/gitlab_ci_yml_template.rb'
    - 'lib/gitlab/template/issue_template.rb'
    - 'lib/gitlab/template/merge_request_template.rb'
    - 'lib/gitlab/template/metrics_dashboard_template.rb'
    - 'lib/gitlab/template/service_desk_template.rb'
    - 'lib/gitlab/throttle.rb'
    - 'lib/gitlab/tracking/event_definition.rb'
    - 'lib/gitlab/untrusted_regexp.rb'
    - 'lib/gitlab/untrusted_regexp/ruby_syntax.rb'
    - 'lib/gitlab/usage/metric.rb'
    - 'lib/gitlab/usage/metric_definition.rb'
    - 'lib/gitlab/visibility_level.rb'
    - 'lib/gitlab/webpack/file_loader.rb'
    - 'lib/release_highlights/validator.rb'
    - 'lib/system_check/app/ruby_version_check.rb'
    - 'lib/system_check/base_check.rb'
    - 'lib/system_check/rake_task/rake_task_helpers.rb'
    - 'lib/uploaded_file.rb'
    - 'qa/lib/gitlab/page/main/sign_up.rb'
    - 'qa/qa/page/validatable.rb'
    - 'qa/qa/resource/base.rb'
    - 'qa/qa/resource/events/project.rb'
    - 'qa/qa/resource/personal_access_token.rb'
    - 'qa/qa/resource/protected_branch.rb'
    - 'qa/qa/resource/user_gpg.rb'
    - 'qa/qa/runtime/release.rb'
    - 'qa/qa/scenario/bootable.rb'
    - 'sidekiq_cluster/sidekiq_cluster.rb'
    - 'spec/graphql/resolvers/group_labels_resolver_spec.rb'
    - 'spec/helpers/emails_helper_spec.rb'
    - 'spec/helpers/feature_flags_helper_spec.rb'
    - 'spec/helpers/graph_helper_spec.rb'
    - 'spec/helpers/ide_helper_spec.rb'
    - 'spec/helpers/submodule_helper_spec.rb'
    - 'spec/lib/gitlab/background_task_spec.rb'
    - 'spec/lib/gitlab/database/load_balancing_spec.rb'
    - 'spec/models/integration_spec.rb'
    - 'spec/support/before_all_adapter.rb'
    - 'spec/support/cycle_analytics_helpers/test_generation.rb'
